#ifndef COMMON_SELFTEST_H
#define COMMON_SELFTEST_H
/* Copyright (C) 2014 by Bundesamt für Sicherheit in der Informationstechnik
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU GPL (v>=2)
 * and comes with ABSOLUTELY NO WARRANTY!
 * See LICENSE.txt for details.
 */

/** @file self test against manipulation
 *
 * The selftest is intended to detect untargeted manipulation or
 * corruption of the executable. Circumvention of the selftest
 * by targeted manipulation of the binary can, of course, not
 * be detected.
 */

#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif
/** @brief check that the current process is signed by the correct certificate
 *
 * Checks that the certificate is signed with a valid signature and the
 * builtin public certificate.
 *
 * @returns true if the selftest is successful. false on error.
 */
bool selftest();

#ifdef __cplusplus
}
#endif
#endif // COMMON_SELFTEST_H
